#*************************************************************
# Progamm:			absorption
# Sinn des Programms: 		Berechnung der Absorption in der ISA-Atmosphäre
# Sinn der Einheit  :		Einlesen der Dichtewerte aus der ISA-Datei	
# Name dieser Datei:		ISA_lese.py
# Versionsnummer:		1
# Wird aufgerufen von:		absorption_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	4
# von:				6			
# Autor: 			Armin Ulrich
# Erster Lauf: 			21.04.2019
# Letzte Änderung: 		23.04.2019
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateifunktionen
#*************************************************************
import os



class ISA_lese:

  def __init__(self):		
    print("ISA_leseobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("ISA_leseobjekt entfernt")   

#*************************************************************
# Funktion zum Öffnen der ISA-datei und zum Auslesen der
# Atmosphärendaten
#*************************************************************
  def isa_input(self):
    print("Einlesen der Atmosphärendaten") 
  
    self.zeilenzähler = 0
    # hoehe(i),T(i),p(i),rho_rel(i),nue(i),lambda(i), c(i)
    if os.path.exists("ISA_standart.dat"):
      print("Datei ist vorhanden")
      
      self.i_max =46 
      self.höhe = list(range(self.i_max))
      self.T = list(range(self.i_max))
      self.p = list(range(self.i_max))
      self.rho_rel = list(range(self.i_max))
      self.nue = list(range(self.i_max))
      self.lambada = list(range(self.i_max))
      self.c = list(range(self.i_max))
      fobj_in = open("ISA_standart.dat","r")
      for line in fobj_in:
        zeile=line.rstrip()
        länge = len(zeile)
        self.puffer = zeile
        dummy=self.puffer.split(" ")
        for i in range(7):
          if(dummy[i][0] == "\t" ):
            dummy[i] = dummy[i][1:] 
        self.höhe[self.zeilenzähler]=float(dummy[0])
        self.T[self.zeilenzähler]=float(dummy[1])
        self.p[self.zeilenzähler]=float(dummy[2])
        self.rho_rel[self.zeilenzähler]=float(dummy[3])
        print(self.rho_rel[self.zeilenzähler])
        self.nue[self.zeilenzähler]=float(dummy[4])
        self.lambada[self.zeilenzähler]=float(dummy[5])
        self.c[self.zeilenzähler]=float(dummy[6])
        self.zeilenzähler += 1
      fobj_in.close()
      return True
    else:
      print("Datei ist NICHT vorhanden")
      return False       

