#*************************************************************
# Progamm 			absorption
# Sinn des Programms: 		Berechnung der Absorption in ISA-Atmosphäre
# Sinn der Einheit  :		Ausgabe
# Name der Datei    :		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		absorption_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	6
# von:				6
# Autor: 			Armin Ulrich
# Erster Lauf: 			12.04.2018
# Letzte Änderung: 		04.06.2020
#*************************************************************


#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os


import matplotlib.pyplot as plt

class Ausgabe:

  def __init__(self):		
    print("Ausgabeobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt")          


  def schirm_ausgabe(self,i_max,kappa,Intens):
    print(i_max,"Schirmaugabe")
    for i in range(i_max):
      print (f"{i:7}", f"{kappa[i]:.6f}", f"{Intens[i]:.7f}")

  def datei_ausgabe(self, ausgabe_datei, k_max, kappa, Intens):  #, Intens_absorbiert):
    fobj_out = open(ausgabe_datei,"w")
    for k in range(k_max):
      fobj_out.write(f"{k:7}")
      fobj_out.write("\t")
      fobj_out.write(f"{kappa[k]:.6f}")       
      fobj_out.write("\t")
      fobj_out.write(f"{Intens[k]:.7f}") 
      fobj_out.write("\n")
    fobj_out.close()
    

  def graphik_ausgabe(self,k_max,kappa_anfang,kappa_ende, kappa, Intens):
    titel = "Gesamte absorbierte Intensität bei kappa_init = " +str(kappa_anfang)+ " bis " + str(kappa_ende)
    kappa_min=0.0
    kappa_max=0.0
    Intens_min=0.0
    Intens_max=0.0
    for k in range(k_max):
      if kappa_min >= kappa[k]:
        kappa_min = kappa[k]
      if kappa_max <= kappa[k]:
        kappa_max = kappa[k]
      if Intens_min >= Intens[k]:
        Intens_min = Intens[k]
      if Intens_max <= Intens[k]:
        Intens_max = Intens[k]
    #for i in range(i_max):
    plt.plot(kappa, Intens, 'r.',label=r'numerische Lösung')
    
    
    
      # Achsen-Bereiche manuell festlegen
    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
    kappa_min-=(kappa_max-kappa_min)/10.0
    kappa_max+=(kappa_max-kappa_min)/10.0
    Intens_min-=(Intens_max-Intens_min)/10.0
    Intens_max+=(Intens_max-Intens_min)/10.0
    plt.axis([kappa_min, kappa_max, Intens_min, Intens_max])
    plt.title(titel)
    plt.xlabel("kappa [1/m]")
    plt.ylabel('Intensität [W/m²]')
    plt.legend(loc='upper right', frameon=True)
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    plt.savefig("absorbierte_Intensitaet_bei_kappa_variabel.png", format='png')
     # Diagramm anzeigen:
    plt.show()

