#*************************************************************
# Progamm:			absorption
# Sinn des Programms: 		Berechnung der Absorption in der ISA-Atmosphäre
# Sinn der Einheit  :		Berechnung der kappa- und Intensitätswerte	
# Name dieser Datei:		rechner.py
# Versionsnummer:		1
# Wird aufgerufen von:		absorption_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	5
# von:				6			
# Autor: 			Armin Ulrich
# Erster Lauf: 			23.04.2019
# Letzte Änderung: 		28.04.2019
#*************************************************************


class Rechner:

  def __init__(self):		
    print("Rechnerobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Rechnerobjekt entfernt")   

  def kappa_rechner(self,Intens_init,kappa_anfang,kappa_ende,kappa_schrittweite,i_max,h_gitter,delta_h_gitter,j_max,h_isa,rho_rel):
    if (kappa_ende-kappa_anfang)/kappa_schrittweite == int((kappa_ende-kappa_anfang)/kappa_schrittweite): 
      self.k_max=int((kappa_ende-kappa_anfang)/kappa_schrittweite)#+1 hier nochmal genau überlegen.
      print("oberheiden peitschen")
    else:
      self.k_max=int((kappa_ende-kappa_anfang)/kappa_schrittweite)+1
      print("kunze peitschen")
    self.Intens_rest=list(range(self.k_max))
    self.Intens_absorbiert=list(range(self.k_max))
    self.kappa_init_feld=list(range(self.k_max))
    self.kappa = list(range(i_max)) 
    self.Intens = list(range(i_max)) 
    self.Intens[0]=Intens_init
    
    kappa_init = kappa_anfang
    k=0
    while kappa_init <= kappa_ende:
      for i in range(i_max):
        for j in range(j_max-1):  #Zählschleife hier schlecht
          if ((h_isa[j]<=h_gitter[i]) & (h_gitter[i]<h_isa[j+1])):
            rho_rel_ges=rho_rel[j]*(h_isa[j+1]-h_gitter[i])/(h_isa[j+1]-h_isa[j])+rho_rel[j+1]*(h_gitter[i]-h_isa[j])/(h_isa[j+1]-h_isa[j])
            self.kappa[i] = kappa_init*rho_rel_ges
       #print(i,rho_rel_ges, kappa[i],Intens[i])
      print(self.Intens[0])
      for i in range(i_max-1):
        self.Intens[i+1]=self.euler(self.Intens[i], self.kappa[i], delta_h_gitter[i])
      #for i in range(i_max):
      #  print(i,self.Intens[i])
      self.Intens_rest[k]=self.Intens[i_max-1]
      self.Intens_absorbiert[k] = Intens_init - self.Intens_rest[k]
      #print("Restintensität:",k,self.Intens_rest[k],"Absorbierte Intensität:",k,self.Intens_absorbiert[k])
      self.kappa_init_feld[k]=kappa_init
      kappa_init=kappa_init+kappa_schrittweite
      k+=1
 
  def euler(self,Intens, kappa, delta_h):
    #print("Eulerschritt",delta_h)
    Intens_neu=Intens*(1.0-kappa*delta_h) 
    return Intens_neu   
  


 
